include \masm32\MasmBasic\MasmBasic.inc	; [url=http://www.masm32.com/board/index.php?topic=12460]download[/url]
include \masm32\macros\timers.asm	; get MichaelW's timers from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
  Init
  push 1
  call ShowCpu	; print brand string and SSE level
  .if Exist("\Masm32\include\WindowsWide.inc")		; to test this, open the ANSI version in an editor and save as UNICODE
	wLet esi=FileRead$("\Masm32\include\WindowsWide.inc")		; Let or wLet are the same for a plain FileRead$()
	Print Str$("%i chars read, including BOM", wLen(esi)), Str$(", filesize=%i\n", LastFileSize)
	Print Str$("wCount equ=\t%i\n", wCount(esi, wChr$("equ")))
  .endif
  Let esi=FileRead$("\Masm32\include\Windows.inc")
  Print Str$("%i chars read\n", Len(esi))
  Print Str$(" Count equ=\t%i\n\n", Count(esi, Chr$("equ")))		; 1 is correct!
  LoopCount=100
  REPEAT 2
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		void Count(849500, esi, "EQU", 5))		; start counting near the end of the file buffer
	counter_end
	print str$(eax), 9, "cycles for Count EQU, start at byte 849500", 13, 10
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		void Count(1, esi, "EQU"))
	counter_end
	sar eax, 10
	print str$(eax), 9, "kCycles for Count EQU, complete Windows.inc", 13, 10
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		void Count(1, esi, "EQU", 5))
	counter_end
	sar eax, 10
	print str$(eax), 9, "kCycles for Count EQU, whole word and case-insensitive", 13, 10
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		void Count(1, esi, "E"))
	counter_end
	sar eax, 10
	print str$(eax), 9, "kCycles for Count E", 13, 10
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		void Count(1, esi, "e"))
	counter_end
	sar eax, 10
	print str$(eax), 9, "kCycles for Count e", 13, 10, 10
  ENDM
  Exit
ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

3000 kCycles/0.89MB = 3000000/0.89=3370786c/MB; 1600000000/3370786 MB/s = 475 MB/second

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
849789 chars read, including BOM, filesize=1699578
wCount equ=     14857
849788 chars read
 Count equ=     14857

1014    cycles for Count EQU, start at byte 849500
2911    kCycles for Count EQU, complete Windows.inc
3456    kCycles for Count EQU, whole word and case-insensitive
5056    kCycles for Count E
4382    kCycles for Count e

OPT_Assembler	jwasm	; must be present in \bin
OPT_Tmp2Asm	1
